//Avatar Save and Load Events
//Author: Gothboy77 BLID 14329
//-----------------------------
//Register Events
registerOutputEvent("GameConnection","avatarClear","",1);
registerOutputEvent("GameConnection","avatarSave","",1);
registerOutputEvent("GameConnection","avatarLoad","",1);
//Clear the clients avatar
function GameConnection::avatarClear(%client)
{
	%client.avatarSaved = false;
	%client.applyBodyColors();
	%client.applyBodyParts();
}
//Save the clients avatar
function GameConnection::avatarSave(%client)
{
	//Store current avatar values
	%client.avatarAccent			= %client.Accent;
	%client.avatarAccentColor		= %client.AccentColor;
	%client.avatarChest				= %client.Chest;
	%client.avatarChestColor		= %client.ChestColor;
	%client.avatarDecalColor		= %client.DecalColor;
	%client.avatarDecalName			= %client.DecalName;
	%client.avatarFaceColor			= %client.FaceColor;
	%client.avatarFaceName			= %client.FaceName;
	%client.avatarHat				= %client.Hat;
	%client.avatarHatColor			= %client.HatColor;
	%client.avatarHeadColor			= %client.HeadColor;
	%client.avatarHip				= %client.Hip;
	%client.avatarHipColor			= %client.HipColor;
	%client.avatarLArm				= %client.LArm;
	%client.avatarLArmColor			= %client.LArmColor;
	%client.avatarLHand				= %client.LHand;
	%client.avatarLHandColor		= %client.LHandColor;
	%client.avatarLLeg				= %client.LLeg;
	%client.avatarLLegColor			= %client.LLegColor;
	%client.avatarPack				= %client.Pack;
	%client.avatarPackColor			= %client.PackColor;
	%client.avatarRArm				= %client.RArm;
	%client.avatarRArmColor			= %client.RArmColor;
	%client.avatarRHand				= %client.RHand;
	%client.avatarRHandColor		= %client.RHandColor;
	%client.avatarRLeg				= %client.RLeg;
	%client.avatarRLegColor			= %client.RLegColor;
	%client.avatarSecondPack		= %client.SecondPack;
	%client.avatarSecondPackColor	= %client.SecondPackColor;
	%client.avatarTorsoColor		= %client.TorsoColor;
	//We saved our avatar
	%client.avatarSaved = true;
}
//Load the clients saved avatar
function GameConnection::avatarLoad(%client)
{
	if(%client.avatarSaved !$= true)
		return;
	//Load saved avatar values
	%client.Accent					= %client.avatarAccent;
	%client.AccentColor				= %client.avatarAccentColor;
	%client.Chest					= %client.avatarChest;
	%client.ChestColor				= %client.avatarChestColor;
	%client.DecalColor				= %client.avatarDecalColor;
	%client.DecalName				= %client.avatarDecalName;
	%client.FaceColor				= %client.avatarFaceColor;
	%client.FaceName				= %client.avatarFaceName;
	%client.Hat						= %client.avatarHat;
	%client.HatColor				= %client.avatarHatColor;
	%client.HeadColor				= %client.avatarHeadColor;
	%client.Hip						= %client.avatarHip;
	%client.HipColor				= %client.avatarHipColor;
	%client.LArm					= %client.avatarLArm;
	%client.LArmColor				= %client.avatarLArmColor;
	%client.LHand					= %client.avatarLHand;
	%client.LHandColor				= %client.avatarLHandColor;
	%client.LLeg					= %client.avatarLLeg;
	%client.LLegColor				= %client.avatarLLegColor;
	%client.Pack					= %client.avatarPack;
	%client.PackColor				= %client.avatarPackColor;
	%client.RArm					= %client.avatarRArm;
	%client.RArmColor				= %client.avatarRArmColor;
	%client.RHand					= %client.avatarRHand;
	%client.RHandColor				= %client.avatarRHandColor;
	%client.RLeg					= %client.avatarRLeg;
	%client.RLegColor				= %client.avatarRLegColor;
	%client.SecondPack				= %client.avatarSecondPack;
	%client.SecondPackColor			= %client.avatarSecondPackColor;
	%client.TorsoColor				= %client.avatarTorsoColor;
	//Define the player
	if(isObject(%client.player))
		%player = %client.player;
	//Update body parts and colors accordingly
	%player.hideNode("ALL");
	%player.unHideNode((%client.chest ? "femChest" : "chest"));
	%player.unHideNode((%client.rhand ? "rhook" : "rhand"));
	%player.unHideNode((%client.lhand ? "lhook" : "lhand"));
	%player.unHideNode((%client.rarm ? "rarmSlim" : "rarm"));
	%player.unHideNode((%client.larm ? "larmSlim" : "larm"));
	%player.unHideNode("headskin");
	%player.setHeadUp(0);
	//Pack
	if(%client.pack)
	{
		%player.unHideNode($pack[%client.pack]);
		%player.setNodeColor($pack[%client.pack],%client.packColor);
	}
	//Second Pack
	if(%client.secondPack)
	{
		%player.unHideNode($secondPack[%client.secondPack]);
		%player.setNodeColor($secondPack[%client.secondPack],%client.secondPackColor);
	}
	//Bump the player neck up a bit if covered
	if(%client.pack+%client.secondPack > 0)
	{
		%player.setHeadUp(1);
		//Not sure what this function does, putting it here because Space Guy also used it when setHeadUp is called true
		%player.setThreadDir(0,0);
	}
	//Hat
	if(%client.hat)
	{
		%player.unHideNode($hat[%client.hat]);
		%player.setNodeColor($hat[%client.hat],%client.hatColor);
	}
	//Pants
	if(%client.hip)
	{
		%player.unHideNode("skirthip");
		%player.unHideNode("skirttrimleft");
		%player.unHideNode("skirttrimright");
	}
	else
	{
		%player.unHideNode("pants");
		%player.unHideNode((%client.rleg ? "rpeg" : "rshoe"));
		%player.unHideNode((%client.lleg ? "lpeg" : "lshoe"));
	}
	//Visor
	if($hat[%client.hat] $= "Helmet")
	{
		if(%client.accent == 1)
		{
			%player.unHideNode($accent[4]);
			%player.setNodeColor($accent[4],%client.accentColor);
		}
	}
	//Accent
	else if(strPos($accentsAllowed[$hat[%client.hat]],strLwr($accent[%client.accent])) != -1)
	{
		%player.unHideNode($accent[%client.accent]);
		%player.setNodeColor($accent[%client.accent],%client.accentColor);
	}
	//Decals
	%player.setFaceName(%client.faceName);
	%player.setDecalName(%client.decalName);
	//Head
	%player.setNodeColor("headskin",%client.headColor);
	//Body
	%player.setNodeColor("chest",%client.chestColor);
	%player.setNodeColor("femChest",%client.chestColor);
	%player.setNodeColor("pants",%client.hipColor);
	%player.setNodeColor("skirthip",%client.hipColor);
	//Arm
	%player.setNodeColor("rarm",%client.rarmColor);
	%player.setNodeColor("larm",%client.larmColor);
	%player.setNodeColor("rarmSlim",%client.rarmColor);
	%player.setNodeColor("larmSlim",%client.larmColor);
	//Hand
	%player.setNodeColor("rhand",%client.rhandColor);
	%player.setNodeColor("lhand",%client.lhandColor);
	%player.setNodeColor("rhook",%client.rhandColor);
	%player.setNodeColor("lhook",%client.lhandColor);
	//Feet
	%player.setNodeColor("rshoe",%client.rlegColor);
	%player.setNodeColor("lshoe",%client.llegColor);
	%player.setNodeColor("rpeg",%client.rlegColor);
	%player.setNodeColor("lpeg",%client.llegColor);
	%player.setNodeColor("skirttrimright",%client.rlegColor);
	%player.setNodeColor("skirttrimleft",%client.llegColor);
}
//Persistence Support
LoadRequiredAddOn("Script_Player_Persistence");
//A quick way to make sure it loaded and register shit to it
if(isFunction(RegisterPersistenceVar))
{
	RegisterPersistenceVar("avatarSaved", false, "");
	RegisterPersistenceVar("avatarAccent", false, "");
	RegisterPersistenceVar("avatarAccentColor", false, "");
	RegisterPersistenceVar("avatarChest", false, "");
	RegisterPersistenceVar("avatarChestColor", false, "");
	RegisterPersistenceVar("avatarDecalName", false, "");
	RegisterPersistenceVar("avatarDecalColor", false, "");
	RegisterPersistenceVar("avatarFaceName", false, "");
	RegisterPersistenceVar("avatarFaceColor", false, "");
	RegisterPersistenceVar("avatarHat", false, "");
	RegisterPersistenceVar("avatarHatColor", false, "");
	RegisterPersistenceVar("avatarHeadColor", false, "");
	RegisterPersistenceVar("avatarHip", false, "");
	RegisterPersistenceVar("avatarHipColor", false, "");
	RegisterPersistenceVar("avatarLarm", false, "");
	RegisterPersistenceVar("avatarLarmColor", false, "");
	RegisterPersistenceVar("avatarLhand", false, "");
	RegisterPersistenceVar("avatarLhandColor", false, "");
	RegisterPersistenceVar("avatarLleg", false, "");
	RegisterPersistenceVar("avatarLlegColor", false, "");
	RegisterPersistenceVar("avatarPack", false, "");
	RegisterPersistenceVar("avatarPackColor", false, "");
	RegisterPersistenceVar("avatarRarm", false, "");
	RegisterPersistenceVar("avatarRarmColor", false, "");
	RegisterPersistenceVar("avatarRhand", false, "");
	RegisterPersistenceVar("avatarRhandColor", false, "");
	RegisterPersistenceVar("avatarRleg", false, "");
	RegisterPersistenceVar("avatarRlegColor", false, "");
	RegisterPersistenceVar("avatarSecondPack", false, "");
	RegisterPersistenceVar("avatarSecondPackColor", false, "");
	RegisterPersistenceVar("avatarTorsoColor", false, "");
}
//Packaged Functions
package package_avatarEvents
{
	//Apply your saved avatar colors and parts instead
	function gameConnection::applyBodyColors(%client,%obj) 
	{
		if(%client.avatarSaved $= true)
		{
			%client.avatarLoad();
		}
		return parent::applyBodyColors(%client,%obj);
	}
	function gameConnection::applyBodyParts(%client,%obj) 
	{
		if(%client.avatarSaved $= true)
		{
			%client.avatarLoad();
		}
		return parent::applyBodyParts(%client,%obj);
	}
	//Persistence Support
	function gameConnection::applyPersistence(%client, %gotPlayer, %gotCamera)
    {	
		if(%client.avatarSaved $= true)
		{
			%client.avatarLoad();
		}
		return parent::applyPersistence(%client, %gotPlayer, %gotCamera);
	}
};
//Execute Support Events
exec("./support.cs");
activatePackage(package_avatarEvents);