//Avatar Support Events
//Thanks to Amade for original code
//----------------------------------
$nodelist = "armor bicorn bucket cape chest cophat epaulets epauletsranka epauletsrankb epauletsrankc epauletsrankd femchest flarehelmet headskin helmet knithat larm larmslim lhand lhook lpeg lshoe lski pack pants plume pointyhelmet quiver rarm rarmslim rhand rhook rpeg rshoe rski scouthat septplume shoulderpads skirthip skirttrimleft skirttrimright tank triplume visor";
//isNode function
function isnode(%node)
{
	%words = getWordCount($nodelist);
	for(%i = 0; %i < %words; %i++)
	{
		if(getWord($nodelist, %i) $= %node)
		{
			return true;
		}
	}
	return false;
}
//Register Events
registerOutputEvent("FxDTSbrick", "botFireWeapon", "int 0 30000");
registerOutputEvent("FxDTSbrick", "botAvatarEdit", "list setNodeColor 0 hideNode 1 unhideNode 2 setDecal 3 setFace 4" TAB "string 70 70" TAB "paintcolor 0" TAB "string 30 30", true);
registerOutputEvent("Player", "doEmote", "list Alarm 0 Confusion 1 Hate 2 Love 3 PainLow 4 PainMid 5 PainHigh 6 Win 7");
registerOutputEvent("Player", "EditAppearance", "list setNodeColor 0 hideNode 1 unhideNode 2 setDecal 3 setFace 4" TAB "string 70 70" TAB "paintcolor 0" TAB "string 30 30", true);
registerOutputEvent("Player", "playAnimation", "list NONE 0 Activate 1 Attack 2 ChargeSpear 3 FlailArms 4 Jump 5 PlantBrick 6 PlayDead 7 RightArmUp 8 LeftArmUp 9 BothArmsUp 10 ShakeHead 11 Sit 12 SpinWeapon 13 Talk 14 ThrowSpear 15" TAB "int 0 4 3");
//Add support for player gestures through events
function Player::PlayAnimation(%this, %anim, %slot)
{
	switch(%anim)
	{
		case 0: %this.playThread(%slot, "root");
		case 1: %this.playThread(%slot, "activate");
		case 2: %this.playThread(%slot, "armattack");
		case 3: %this.playThread(%slot, "spearcharge");
		case 4: %this.playThread(%slot, "activate2");
		case 5: %this.playThread(%slot, "jump");
		case 6: %this.playThread(%slot, "plant");
		case 7: %this.playThread(%slot, "death1");
		case 8: %this.playThread(%slot, "armreadyright");
		case 9: %this.playThread(%slot, "armreadyleft");
		case 10: %this.playThread(%slot, "armreadyboth");
		case 11: %this.playThread(%slot, "undo");
		case 12: %this.playThread(%slot, "sit");
		case 13: %this.playThread(%slot, "rotCW");
		case 14: %this.playThread(%slot, "talk");
		case 15: %this.playThread(%slot, "spearthrow");
	}
}
//Do a player emote
function Player::doEmote(%this, %num)
{
	switch(%num)
	{
		case 0: if($AddOnLoaded__Emote_Alarm)
		{
			%this.emote(alarmprojectile);
		}
		case 1: if($AddOnLoaded__Emote_Confusion)
		{
			%this.emote(wtfimage);
		}
		case 2: if($AddOnLoaded__Emote_Hate)
		{
			%this.emote(hateimage);
		}
		case 3: if($AddOnLoaded__Emote_Love)
		{
			%this.emote(loveimage);
		}
		case 4: %this.emote(painlowimage);
		case 5: %this.emote(painmidimage);
		case 6: %this.emote(painhighimage);
		case 7: %this.emote(winstarprojectile); serverPlay3D(rewardSound, %this.getHackPosition());
	}
}
//Edit the player appearance
function Player::editAppearance(%this, %action, %node, %color, %str, %client)
{
	//VCE Support
	if(isFunction("FilterVariableString"))
	{
		%client = %this.client;
		%brick = %client.processingBrick;
		%node = filterVariableString(%node, %brick, %client, %client.player);
		%str = filterVariableString(%str, %brick, %client, %client.player);
	}
	//Not exactly sure what %str is supposed to specify anyway - some type of additive/subtractive ?
	%color = getWordCount(%str) == 4 ? %str : getColorIDTable(%color);
	if(isObject(%this))
	{
		//Make sure we got the player model
		if(%this.getDatablock().shapeFile !$= "base/data/shapes/player/m.dts")
		{
			%node = "all";
		}
		//Nodes can be added or removed by "groups"
		%node = strlwr(%node);
		%node = strReplace(%node, "foot", "shoe");
		%node = strReplace(%node, "feet", "LShoe RShoe");
		%node = strReplace(%node, "legs", "LPeg RPeg");
		%node = strReplace(%node, "hands", "LHand RHand");
		%node = strReplace(%node, "arms", "LArm Rarm");
		%node = strReplace(%node, "head", "headskin");
		%node = strReplace(%node, "headskinskin", "headskin");
		%node = strReplace(%node, "cap", "helmet pointyHelmet flareHelmet scoutHat bicorn knitHat");
		%node = strReplace(%node, "accent", "visor plume triplume septplume");
		//We have edited our avatar
		%this.avatarEdited = true;
		//Get action selection
		if(%action < 3)
		{
			if(%node $= "all")
			{
				switch(%action)
				{
					case 0: %this.setNodeColor("ALL", %color);
					case 1: %this.hideNode("ALL");
					case 2: %this.unhideNode("ALL"); %this.setNodeColor("ALL", %color); %this.setHeadUp(true);
				}
				return;
			}
			for(%i = 0; %i < getWordCount(%node); %i++)
			{
				if(!isnode(getWord(%node, %i)))
				{
					return;
				}
			}
		}
		//When hiding or unhiding nodes
		if(%action == 1 || %action == 2)
		{
			%bool = %action == 2;
			for(%i = 0; %i < getWordCount(%node); %i++)
			{
				switch$(getWord(%node, %i))
				{
					case "armor": %this.setHeadUp(%bool); break;
					case "bucket": %this.setHeadUp(%bool); break;
					case "cape": %this.setHeadUp(%bool); break;
					case "pack": %this.setHeadUp(%bool); break;
					case "quiver": %this.setHeadUp(%bool); break;
					case "tank": %this.setHeadUp(%bool); break;
				}
			}
		}
		//When only unhiding or coloring nodes
		if(%action == 0 || %action == 2)
		{
			//Apply node and colors as client objects for avatar saving - there's another way to do this but this works just fine
			if(%node $= "headskin")
			{
				%client.headColor = %color;
			}
			//Hat
			if(%node $= "helmet")
			{
				%client.hat = 1;
				%client.hatColor = %color;
			}
			if(%node $= "pointyHelmet")
			{
				%client.hat = 2;
				%client.hatColor = %color;
			}
			if(%node $= "flareHelmet")
			{
				%client.hat = 3;
				%client.hatColor = %color;
			}
			if(%node $= "scoutHat")
			{
				%client.hat = 4;
				%client.hatColor = %color;
			}
			if(%node $= "bicorn")
			{
				%client.hat = 5;
				%client.hatColor = %color;
			}
			if(%node $= "copHat")
			{
				%client.hat = 6;
				%client.hatColor = %color;
			}
			if(%node $= "knitHat")
			{
				%client.hat = 7;
				%client.hatColor = %color;
			}
			//Accent
			if(%node $= "visor" && %client.hat == 1)
			{
				%client.accent = 1;
				%client.accentColor = %color;
			}
			if(%node $= "plume")
			{
				%client.accent = 1;
				%client.accentColor = %color;
			}
			if(%node $= "triPlume")
			{
				%client.accent = 2;
				%client.accentColor = %color;
			}
			if(%node $= "septPlume")
			{
				%client.accent = 3;
				%client.accentColor = %color;
			}
			//Torso
			if(%node $= "chest")
			{
				%client.chest = 0;
				%client.chestColor = %color;
			}
			if(%node $= "femChest")
			{
				%client.chest = 1;
				%client.chestColor = %color;
			}
			//Pack
			if(%node $= "armor")
			{
				%client.pack = 1;
				%client.packColor = %color;
			}
			if(%node $= "bucket")
			{
				%client.pack = 2;
				%client.packColor = %color;
			}
			if(%node $= "cape")
			{
				%client.pack = 3;
				%client.packColor = %color;
			}
			if(%node $= "pack")
			{
				%client.pack = 4;
				%client.packColor = %color;
			}
			if(%node $= "quiver")
			{
				%client.pack = 5;
				%client.packColor = %color;
			}
			if(%node $= "tank")
			{
				%client.pack = 6;
				%client.packColor = %color;
			}
			//Second Pack
			if(%node $= "epaulets")
			{
				%client.secondPack = 1;
				%client.secondPackColor = %color;
			}
			if(%node $= "epauletsranka")
			{
				%client.secondPack = 2;
				%client.secondPackColor = %color;
			}
			if(%node $= "epauletsrankb")
			{
				%client.secondPack = 3;
				%client.secondPackColor = %color;
			}
			if(%node $= "epauletsrankc")
			{
				%client.secondPack = 4;
				%client.secondPackColor = %color;
			}
			if(%node $= "epauletsrankd")
			{
				%client.secondPack = 5;
				%client.secondPackColor = %color;
			}
			if(%node $= "shoulderpads")
			{
				%client.secondPack = 6;
				%client.secondPackColor = %color;
			}
			//Arms
			if(%node $= "larm")
			{
				%client.larm = 0;
				%client.larmColor = %color;
			}
			if(%node $= "rarm")
			{
				%client.rarm = 0;
				%client.rarmColor = %color;
			}
			if(%node $= "larmSlim")
			{
				%client.larm = 1;
				%client.larmColor = %color;
			}
			if(%node $= "rarmSlim")
			{
				%client.rarm = 1;
				%client.rarmColor = %color;
			}
			//Hands
			if(%node $= "lhand")
			{
				%client.lhand = 0;
				%client.lhandColor = %color;
			}
			if(%node $= "rhand")
			{
				%client.rhand = 0;
				%client.rhandColor = %color;
			}
			if(%node $= "lhook")
			{
				%client.lhand = 1;
				%client.lhandColor = %color;
			}
			if(%node $= "rhook")
			{
				%client.rhand = 1;
				%client.rhandColor = %color;
			}
			//Hip
			if(%node $= "pants")
			{
				%client.hip = 0;
				%client.hipColor = %color;
			}
			if(%node $= "skirtHip")
			{
				%client.hip = 1;
				%client.hipColor = %color;
			}
			//Feet
			if(%node $= "lshoe")
			{
				%client.lleg = 0;
				%client.llegColor = %color;
			}
			if(%node $= "rshoe")
			{
				%client.rleg = 0;
				%client.rlegColor = %color;
			}
			if(%node $= "lpeg")
			{
				%client.lleg = 1;
				%client.llegColor = %color;
			}
			if(%node $= "rpeg")
			{
				%client.rleg = 1;
				%client.rlegColor = %color;
			}
			//Trim
			if(%node $= "skirttrimleft" && %client.hip == 1)
			{
				%client.rleg = 1;
				%client.llegColor = %color;
			}
			if(%node $= "skirttrimright" && %client.hip == 1)
			{
				%client.rleg = 1;
				%client.rlegColor = %color;
			}	
		}
		//When only hiding nodes
		if(%action == 1)
		{
			if(%node $= "headskin")
			{
				%client.head = "none";
			}
			//Hat
			if(%node $= "hat")
			{
				%client.hat = 0;
			}
			//Accent
			if(%node $= "accent")
			{
				%client.accent = 0;
			}
			//Torso
			if(%node $= "chest")
			{
				%client.chest = "none";
			}
			//Pack
			if(%node $= "pack")
			{
				%client.pack = 0;
			}
			//Second Pack
			if(%node $= "secondPack")
			{
				%client.secondPack = 0;
			}
			//Hands
			if(%node $= "hands")
			{
				%client.lhand = 0;
				%client.rhand = 0;
			}
			if(%node $= "lhand")
			{
				%client.lhand = 0;
			}
			if(%node $= "rhand")
			{
				%client.rhand = 0;
			}
			if(%node $= "lhook")
			{
				%client.lhand = 0;
			}
			if(%node $= "rhook")
			{
				%client.rhand = 0;
			}
			//Hip
			if(%node $= "hip")
			{
				%client.hip = "none";
			}
			//Feet
			if(%node $= "feet")
			{
				%client.lleg = 0;
				%client.rleg = 0;
			}
			if(%node $= "lshoe")
			{
				%client.lleg = 0;
			}
			if(%node $= "rshoe")
			{
				%client.rleg = 0;
			}
			if(%node $= "lpeg")
			{
				%client.lleg = 1;
			}
			if(%node $= "rpeg")
			{
				%client.rleg = 1;
			}
		}
		for(%i = 0; %i < getWordCount(%node); %i++)
		{
			%n = getWord(%node, %i);
			switch(%action)
			{
				case 0: %this.setNodeColor(%n, %color);
				case 1: %this.hidenode(%n);
				case 2: %this.unhidenode(%n); %this.setNodeColor(%n, %color);
				case 3: %this.setDecalName(%n); %this.client.decalName = %n;
				case 4: %this.setFaceName(%n); %this.client.faceName = %n;
			}
		}
	}
}
//Fire the weapon you are holding
function Player::FireWeapon(%this,%time)
{
	if(%this.getClassName() $= "AIplayer" || %this.getClassName() $= "Player")
	{
		%this.setImageTrigger(0,1);
		%this.schedule(%time,setImageTrigger,0,0);
	}
}
//Edit Appearance for Bot Hole Bricks
function FxDTSbrick::botAvatarEdit(%this, %action, %node, %color, %str, %client)
{
	if(isObject(%obj = %this.hBot))
	{
		if(%obj.getClassName() $= "AIplayer")
		{
			%obj.avatarEdit(%action, %node, %color, %str, %client);
		}
	}
}
//Fire Weapon for Bot Hole Bricks
function FxDTSbrick::botFireWeapon(%this,%slot)
{
	if(isObject(%obj = %this.hBot))
	{
		if(%obj.getClassName() $= "AIplayer")
		{
			%obj.FireWeapon(%slot);
		}
	}
}